Loading...
Searching...
No Matches
ON_BrepFace Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_brep.h>`

Inheritance diagram for ON_BrepFace:

## Public Member Functions

void | DestroyRuntimeCache (bool bDelete=true)
| ON_BrepFace ()
| ~ON_BrepFace ()
| ON_BrepFace (int)
ON_BrepFace & | operator= (const ON_BrepFace &)
ON_Brep * | Brep () const
ON_BrepLoop * | Loop (int fli) const
int | LoopCount () const
ON_BrepLoop * | OuterLoop () const
class ON_BrepFaceSide * | FaceSide (int dir) const
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_COMPONENT_INDEX | ComponentIndex () const
void | ClearBoundingBox ()
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Reverse (int dir)
ON_BOOL32 | Transpose ()
ON_BOOL32 | SetDomain (int dir, double t0, double t1)
bool | SetDomain (ON_Interval udom, ON_Interval vdom)
bool | SetMesh (ON::mesh_type, ON_Mesh *mesh)
const ON_Mesh * | Mesh (ON::mesh_type mesh_type) const
void | DestroyMesh (ON::mesh_type mesh_type, bool bDeleteMesh=true)
bool | TransformTrim (const ON_Xform &xform)
bool | ChangeSurface (int si)
bool | ChangeSurface (int si, bool bTransformTrimCurves)
int | SurfaceIndexOf () const
const ON_Surface * | SurfaceOf () const
Public Member Functions inherited from ON_SurfaceProxy
void | DestroyRuntimeCache (bool bDelete=true)
| ON_SurfaceProxy ()
| ON_SurfaceProxy (const ON_Surface *)
| ON_SurfaceProxy (const ON_SurfaceProxy &)
ON_SurfaceProxy & | operator= (const ON_SurfaceProxy &)
virtual | ~ON_SurfaceProxy ()
void | SetProxySurface (const ON_Surface *proxy_surface)
const ON_Surface * | ProxySurface () const
bool | ProxySurfaceIsTransposed () const
virtual ON_Surface * | DuplicateSurface () const
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_Interval | Domain (int) const
ON_BOOL32 | GetSurfaceSize (double *width, double *height) const
int | SpanCount (int) const
ON_BOOL32 | GetSpanVector (int, double *) const
int | Degree (int) const
ON_BOOL32 | GetParameterTolerance (int, double, double *, double *) const
ISO | IsIsoparametric (const ON_Curve &curve, const ON_Interval *curve_domain=NULL) const
ISO | IsIsoparametric (const ON_BoundingBox &bbox) const
ON_BOOL32 | IsPlanar (ON_Plane *plane=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (int) const
ON_BOOL32 | IsPeriodic (int) const
ON_BOOL32 | IsSingular (int) const
bool | GetNextDiscontinuity (int dir, ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double s, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse (int)
ON_BOOL32 | Transpose ()
ON_BOOL32 | Evaluate (double, double, int, int, double *, int=0, int *=0) const
ON_Curve * | IsoCurve (int dir, double c) const
int | GetNurbForm (ON_NurbsSurface &, double=0.0) const
int | HasNurbForm () const
bool | GetSurfaceParameterFromNurbFormParameter (double nurbs_s, double nurbs_t, double *surface_s, double *surface_t) const
bool | GetNurbFormParameterFromSurfaceParameter (double surface_s, double surface_t, double *nurbs_s, double *nurbs_t) const
Public Member Functions inherited from ON_Surface
| ON_Surface ()
| ON_Surface (const ON_Surface &)
ON_Surface & | operator= (const ON_Surface &)
virtual | ~ON_Surface ()
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
ON::object_type | ObjectType () const
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_BOOL32 | GetDomain (int dir, double *t0, double *t1) const
bool | SetDomain (int dir, ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (int dir, double t, int side, int *span_vector_index, ON_Interval *span_interval) const
bool | IsSphere (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCylinder (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCone (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsTorus (ON_Torus *torus=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsSolid () const
bool | IsAtSingularity (double s, double t, bool bExact=true) const
int | IsAtSeam (double s, double t) const
ON_3dPoint | PointAt (double, double) const
ON_3dVector | NormalAt (double, double) const
ON_BOOL32 | FrameAt (double u, double v, ON_Plane &frame) const
ON_BOOL32 | EvPoint (double u, double v, ON_3dPoint &point, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &duu, ON_3dVector &duv, ON_3dVector &dvv, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &normal, int=0, int *=0) const
virtual ON_BOOL32 | Trim (int dir, const ON_Interval &domain)
virtual bool | Extend (int dir, const ON_Interval &domain)
virtual ON_BOOL32 | Split (int dir, double c, ON_Surface *&west_or_south_side, ON_Surface *&east_or_north_side) const
ON_NurbsSurface * | NurbsSurface (ON_NurbsSurface *pNurbsSurface=NULL, double tolerance=0.0, const ON_Interval *s_subdomain=NULL, const ON_Interval *t_subdomain=NULL) const
void | DestroySurfaceTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_U | m_face_user
int | m_face_index
ON_SimpleArray< int > | m_li
int | m_si
bool | m_bRev
int | m_face_material_channel
ON_UUID | m_face_uuid

## Friends

class | ON_Brep

## Additional Inherited Members

Public Types inherited from ON_Surface
enum | ISO { not_iso = 0 , x_iso = 1 , y_iso = 2 , W_iso = 3 , S_iso = 4 , E_iso = 5 , N_iso = 6 , iso_count = 7 }

## Detailed Description

Definition at line 990 of file opennurbs_brep.h.

## Constructor & Destructor Documentation

## ON_BrepFace() [1/2]

ON_BrepFace::ON_BrepFace | ( |  | ) |

## ~ON_BrepFace()

ON_BrepFace::~ON_BrepFace | ( |  | ) |

## ON_BrepFace() [2/2]

ON_BrepFace::ON_BrepFace | ( | int |  | ) |

## Member Function Documentation

## Brep()

ON_Brep * ON_BrepFace::Brep | ( |  | ) | const

## ChangeSurface() [1/2]

bool ON_BrepFace::ChangeSurface | ( | int | si | ) |

## ChangeSurface() [2/2]

bool ON_BrepFace::ChangeSurface | ( | int | si,
|  | bool | bTransformTrimCurves
| ) |  |

## ClearBoundingBox()

void ON_BrepFace::ClearBoundingBox | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## ComponentIndex()

ON_COMPONENT_INDEX ON_BrepFace::ComponentIndex | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## DataCRC()

ON__UINT32 ON_BrepFace::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## DestroyMesh()

void ON_BrepFace::DestroyMesh | ( | ON::mesh_type | mesh_type,
|  | bool | bDeleteMesh = `true`
| ) |  |

## DestroyRuntimeCache()

void ON_BrepFace::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dump()

void ON_BrepFace::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## FaceSide()

class ON_BrepFaceSide * ON_BrepFace::FaceSide | ( | int | dir | ) | const

## GetBBox()

ON_BOOL32 ON_BrepFace::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## IsValid()

ON_BOOL32 ON_BrepFace::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Loop()

ON_BrepLoop * ON_BrepFace::Loop | ( | int | fli | ) | const

## LoopCount()

int ON_BrepFace::LoopCount | ( |  | ) | const

## Mesh()

const ON_Mesh * ON_BrepFace::Mesh | ( | ON::mesh_type | mesh_type | ) | const

## operator=()

ON_BrepFace & ON_BrepFace::operator= | ( | const ON_BrepFace & |  | ) |

## OuterLoop()

ON_BrepLoop * ON_BrepFace::OuterLoop | ( |  | ) | const

## Read()

ON_BOOL32 ON_BrepFace::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## Reverse()

ON_BOOL32 ON_BrepFace::Reverse | ( | int | dir | ) |

virtual

Implements ON_Surface.

## SetDomain() [1/2]

ON_BOOL32 ON_BrepFace::SetDomain | ( | int | dir,
|  | double | t0,
|  | double | t1
| ) |  |

virtual

Reimplemented from ON_Surface.

## SetDomain() [2/2]

bool ON_BrepFace::SetDomain | ( | ON_Interval | udom,
|  | ON_Interval | vdom
| ) |  |

## SetMesh()

bool ON_BrepFace::SetMesh | ( | ON::mesh_type | ,
|  | ON_Mesh * | mesh
| ) |  |

## SizeOf()

unsigned int ON_BrepFace::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SurfaceIndexOf()

int ON_BrepFace::SurfaceIndexOf | ( |  | ) | const

## SurfaceOf()

const ON_Surface * ON_BrepFace::SurfaceOf | ( |  | ) | const

## TransformTrim()

bool ON_BrepFace::TransformTrim | ( | const ON_Xform & | xform | ) |

## Transpose()

ON_BOOL32 ON_BrepFace::Transpose | ( |  | ) |

virtual

Implements ON_Surface.

## Write()

ON_BOOL32 ON_BrepFace::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Friends And Related Symbol Documentation

## ON_Brep

friend class ON_Brep

friend

Definition at line 1287 of file opennurbs_brep.h.

## Member Data Documentation

## m_bRev

bool ON_BrepFace::m_bRev

Definition at line 1258 of file opennurbs_brep.h.

## m_face_index

int ON_BrepFace::m_face_index

Definition at line 1003 of file opennurbs_brep.h.

## m_face_material_channel

int ON_BrepFace::m_face_material_channel

Definition at line 1274 of file opennurbs_brep.h.

## m_face_user

ON_U ON_BrepFace::m_face_user

Definition at line 1001 of file opennurbs_brep.h.

## m_face_uuid

ON_UUID ON_BrepFace::m_face_uuid

Definition at line 1277 of file opennurbs_brep.h.

## m_li

ON_SimpleArray<int> ON_BrepFace::m_li

Definition at line 1256 of file opennurbs_brep.h.

## m_si

int ON_BrepFace::m_si

Definition at line 1257 of file opennurbs_brep.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_brep.h